(* File lexer.mll *)
{
type token = INT of int | LPAREN | RPAREN | PLUS | MINUS | TIMES | DIV | EOL;;

exception Eof;;

let print_token = function
          INT(i) -> print_string ("Num("^(string_of_int i)^") ")
        | LPAREN -> print_string "LPAREN "
	| RPAREN -> print_string "RPAREN "
	| PLUS -> print_string "PLUS "
	| MINUS -> print_string "MINUS "
	| TIMES -> print_string "TIMES "
	| DIV -> print_string "DIV "
        | EOL -> print_string "EOL "
;;
}
rule token = parse
[' ' '\t']     { token lexbuf }     (* skip blanks *)
| ['\n' ]        { EOL }
| ['0'-'9']+     { INT(int_of_string(Lexing.lexeme lexbuf)) }
| '+'            { PLUS }
| '-'            { MINUS }
| '*'            { TIMES }
| '/'            { DIV }
| '('            { LPAREN }
| ')'            { RPAREN }
| eof            { raise Eof }

{

let _ =
try
let lexbuf = Lexing.from_channel stdin in
while true do
print_token (token lexbuf)
done
with Eof ->
print_newline(); exit 0
}
